(function(root, factory) {
  if (typeof define === 'function' && define.amd) 
    define(['exports', 'kotlin', 'kotlinx-serialization-kotlinx-serialization-core-js-legacy', 'ktor-ktor-http-js-legacy', 'ktor-ktor-io-js-legacy', 'ktor-ktor-shared-serialization-js-legacy'], factory);
  else if (typeof exports === 'object') 
    factory(module.exports, require('kotlin'), require('kotlinx-serialization-kotlinx-serialization-core-js-legacy'), require('ktor-ktor-http-js-legacy'), require('ktor-ktor-io-js-legacy'), require('ktor-ktor-shared-serialization-js-legacy'));
  else {
    if (typeof kotlin === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-shared-serialization-kotlinx-js-legacy'. Its dependency 'kotlin' was not found. Please, check whether 'kotlin' is loaded prior to 'ktor-ktor-shared-serialization-kotlinx-js-legacy'.");
    }
    if (typeof this['kotlinx-serialization-kotlinx-serialization-core-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-shared-serialization-kotlinx-js-legacy'. Its dependency 'kotlinx-serialization-kotlinx-serialization-core-js-legacy' was not found. Please, check whether 'kotlinx-serialization-kotlinx-serialization-core-js-legacy' is loaded prior to 'ktor-ktor-shared-serialization-kotlinx-js-legacy'.");
    }
    if (typeof this['ktor-ktor-http-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-shared-serialization-kotlinx-js-legacy'. Its dependency 'ktor-ktor-http-js-legacy' was not found. Please, check whether 'ktor-ktor-http-js-legacy' is loaded prior to 'ktor-ktor-shared-serialization-kotlinx-js-legacy'.");
    }
    if (typeof this['ktor-ktor-io-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-shared-serialization-kotlinx-js-legacy'. Its dependency 'ktor-ktor-io-js-legacy' was not found. Please, check whether 'ktor-ktor-io-js-legacy' is loaded prior to 'ktor-ktor-shared-serialization-kotlinx-js-legacy'.");
    }
    if (typeof this['ktor-ktor-shared-serialization-js-legacy'] === 'undefined') {
      throw new Error("Error loading module 'ktor-ktor-shared-serialization-kotlinx-js-legacy'. Its dependency 'ktor-ktor-shared-serialization-js-legacy' was not found. Please, check whether 'ktor-ktor-shared-serialization-js-legacy' is loaded prior to 'ktor-ktor-shared-serialization-kotlinx-js-legacy'.");
    }
    root['ktor-ktor-shared-serialization-kotlinx-js-legacy'] = factory(typeof this['ktor-ktor-shared-serialization-kotlinx-js-legacy'] === 'undefined' ? {} : this['ktor-ktor-shared-serialization-kotlinx-js-legacy'], kotlin, this['kotlinx-serialization-kotlinx-serialization-core-js-legacy'], this['ktor-ktor-http-js-legacy'], this['ktor-ktor-io-js-legacy'], this['ktor-ktor-shared-serialization-js-legacy']);
  }
}(this, function(_, Kotlin, $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy, $module$ktor_ktor_http_js_legacy, $module$ktor_ktor_io_js_legacy, $module$ktor_ktor_shared_serialization_js_legacy) {
  'use strict';
  var COROUTINE_SUSPENDED = Kotlin.kotlin.coroutines.intrinsics.COROUTINE_SUSPENDED;
  var CoroutineImpl = Kotlin.kotlin.coroutines.CoroutineImpl;
  var SerializationException = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.SerializationException;
  var KSerializer = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.KSerializer;
  var throwCCE = Kotlin.throwCCE;
  var withCharset = $module$ktor_ktor_http_js_legacy.io.ktor.http.withCharset_73qf4i$;
  var TextContent = $module$ktor_ktor_http_js_legacy.io.ktor.http.content.TextContent;
  var StringFormat = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.StringFormat;
  var ByteArrayContent = $module$ktor_ktor_http_js_legacy.io.ktor.http.content.ByteArrayContent;
  var BinaryFormat = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.BinaryFormat;
  var readRemaining = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.readRemaining_3dmw3p$;
  var readText = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.core.readText_1lnizf$;
  var readBytes = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.core.readBytes_xc9h3n$;
  var discard = $module$ktor_ktor_io_js_legacy.io.ktor.utils.io.core.discard_7wsnj1$;
  var Kind_CLASS = Kotlin.Kind.CLASS;
  var ContentConverter = $module$ktor_ktor_shared_serialization_js_legacy.io.ktor.shared.serialization.ContentConverter;
  var IllegalArgumentException_init = Kotlin.kotlin.IllegalArgumentException_init_pdl1vj$;
  var IllegalStateException_init = Kotlin.kotlin.IllegalStateException_init_pdl1vj$;
  var serializerOrNull = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.serializerOrNull_ca95z9$;
  var serializer = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.serializer_1yb8b7$;
  var ListSerializer = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.builtins.ListSerializer_swdriu$;
  var List = Kotlin.kotlin.collections.List;
  var firstOrNull = Kotlin.kotlin.collections.firstOrNull_us0mfu$;
  var kotlin_js_internal_StringCompanionObject = Kotlin.kotlin.js.internal.StringCompanionObject;
  var serializer_0 = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.builtins.serializer_6eet4j$;
  var SetSerializer = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.builtins.SetSerializer_swdriu$;
  var Set = Kotlin.kotlin.collections.Set;
  var MapSerializer = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.builtins.MapSerializer_2yqygg$;
  var Map = Kotlin.kotlin.collections.Map;
  var filterNotNull = Kotlin.kotlin.collections.filterNotNull_m3lr2h$;
  var singleOrNull = Kotlin.kotlin.collections.singleOrNull_2p1efm$;
  var get_nullable = $module$kotlinx_serialization_kotlinx_serialization_core_js_legacy.kotlinx.serialization.builtins.get_nullable_2418p6$;
  var collectionSizeOrDefault = Kotlin.kotlin.collections.collectionSizeOrDefault_ba2ldo$;
  var ArrayList_init = Kotlin.kotlin.collections.ArrayList_init_ww73n8$;
  var HashSet_init = Kotlin.kotlin.collections.HashSet_init_287e2$;
  var ArrayList_init_0 = Kotlin.kotlin.collections.ArrayList_init_287e2$;
  var Collection = Kotlin.kotlin.collections.Collection;
  function KotlinxSerializationConverter(format) {
    this.format_0 = format;
    if (!(Kotlin.isType(this.format_0, BinaryFormat) || Kotlin.isType(this.format_0, StringFormat))) {
      var message = 'Only binary and string formats are supported, ' + (this.format_0.toString() + ' is not supported.');
      throw IllegalArgumentException_init(message.toString());
    }
  }
  KotlinxSerializationConverter.prototype.serialize_4ln4px$ = function(contentType, charset, typeInfo, value, continuation) {
  var tmp$;
  try {
    tmp$ = this.serializeContent_0(serializerFromTypeInfo(typeInfo, this.format_0.serializersModule), this.format_0, value, contentType, charset);
  }  catch (cause) {
  if (Kotlin.isType(cause, SerializationException)) {
    tmp$ = null;
  } else 
    throw cause;
}
  var result = tmp$;
  if (result != null) {
    return result;
  }
  var guessedSearchSerializer = guessSerializer(value, this.format_0.serializersModule);
  return this.serializeContent_0(guessedSearchSerializer, this.format_0, value, contentType, charset);
};
  KotlinxSerializationConverter.prototype.serializeContent_0 = function(serializer, format, value, contentType, charset) {
  var tmp$, tmp$_0, tmp$_1;
  if (Kotlin.isType(format, StringFormat)) {
    var content = format.encodeToString_tf03ej$(Kotlin.isType(tmp$ = serializer, KSerializer) ? tmp$ : throwCCE(), value);
    tmp$_1 = new TextContent(content, withCharset(contentType, charset));
  } else if (Kotlin.isType(format, BinaryFormat)) {
    var content_0 = format.encodeToByteArray_tf03ej$(Kotlin.isType(tmp$_0 = serializer, KSerializer) ? tmp$_0 : throwCCE(), value);
    tmp$_1 = new ByteArrayContent(content_0, contentType);
  } else {
    throw IllegalStateException_init(('Unsupported format ' + format).toString());
  }
  return tmp$_1;
};
  function Coroutine$deserialize_obau6j$($this, charset_0, typeInfo_0, content_0, continuation_0) {
    CoroutineImpl.call(this, continuation_0);
    this.exceptionState_0 = 1;
    this.$this = $this;
    this.local$serializer = void 0;
    this.local$charset = charset_0;
    this.local$typeInfo = typeInfo_0;
    this.local$content = content_0;
  }
  Coroutine$deserialize_obau6j$.$metadata$ = {
  kind: Kotlin.Kind.CLASS, 
  simpleName: null, 
  interfaces: [CoroutineImpl]};
  Coroutine$deserialize_obau6j$.prototype = Object.create(CoroutineImpl.prototype);
  Coroutine$deserialize_obau6j$.prototype.constructor = Coroutine$deserialize_obau6j$;
  Coroutine$deserialize_obau6j$.prototype.doResume = function() {
  do try {
    switch (this.state_0) {
      case 0:
        var tmp$, tmp$_0;
        this.local$serializer = serializerFromTypeInfo(this.local$typeInfo, this.$this.format_0.serializersModule);
        this.state_0 = 2;
        this.result_0 = readRemaining(this.local$content, this);
        if (this.result_0 === COROUTINE_SUSPENDED) 
          return COROUTINE_SUSPENDED;
        continue;
      case 1:
        throw this.exception_0;
      case 2:
        var contentPacket = this.result_0;
        tmp$ = this.$this.format_0;
        if (Kotlin.isType(tmp$, StringFormat)) 
          tmp$_0 = this.$this.format_0.decodeFromString_awif5v$(this.local$serializer, readText(contentPacket, this.local$charset));
        else if (Kotlin.isType(tmp$, BinaryFormat)) 
          tmp$_0 = this.$this.format_0.decodeFromByteArray_dntfbn$(this.local$serializer, readBytes(contentPacket));
        else {
          discard(contentPacket);
          throw IllegalStateException_init(('Unsupported format ' + this.$this.format_0).toString());
        }
        return tmp$_0;
      default:
        this.state_0 = 1;
        throw new Error('State Machine Unreachable execution');
    }
  }  catch (e) {
  if (this.state_0 === 1) {
    this.exceptionState_0 = this.state_0;
    throw e;
  } else {
    this.state_0 = this.exceptionState_0;
    this.exception_0 = e;
  }
} while (true);
};
  KotlinxSerializationConverter.prototype.deserialize_obau6j$ = function(charset_0, typeInfo_0, content_0, continuation_0, suspended) {
  var instance = new Coroutine$deserialize_obau6j$(this, charset_0, typeInfo_0, content_0, continuation_0);
  if (suspended) 
    return instance;
  else 
    return instance.doResume(null);
};
  KotlinxSerializationConverter.$metadata$ = {
  kind: Kind_CLASS, 
  simpleName: 'KotlinxSerializationConverter', 
  interfaces: [ContentConverter]};
  function serialization($receiver, contentType, format) {
    $receiver.register_cav41q$(contentType, new KotlinxSerializationConverter(format));
  }
  function serialization_0($receiver, contentType, format) {
    $receiver.register_cav41q$(contentType, new KotlinxSerializationConverter(format));
  }
  function serializerFromTypeInfo(typeInfo, module_0) {
    var tmp$, tmp$_0, tmp$_1;
    return (tmp$_1 = (tmp$_0 = module_0.getContextual_2n2k9f$(typeInfo.type)) != null ? tmp$_0 : (tmp$ = typeInfo.kotlinType) != null ? serializerOrNull(module_0, tmp$) : null) != null ? tmp$_1 : serializer(typeInfo.type);
  }
  function guessSerializer(value, module_0) {
    var tmp$, tmp$_0, tmp$_1, tmp$_2, tmp$_3;
    if (Kotlin.isType(value, List)) 
      tmp$_2 = ListSerializer(elementSerializer(value, module_0));
    else if (Kotlin.isArray(value)) {
      tmp$_2 = (tmp$_0 = (tmp$ = firstOrNull(value)) != null ? guessSerializer(tmp$, module_0) : null) != null ? tmp$_0 : ListSerializer(serializer_0(kotlin_js_internal_StringCompanionObject));
    } else if (Kotlin.isType(value, Set)) 
      tmp$_2 = SetSerializer(elementSerializer(value, module_0));
    else if (Kotlin.isType(value, Map)) {
      var keySerializer = elementSerializer(value.keys, module_0);
      var valueSerializer = elementSerializer(value.values, module_0);
      tmp$_2 = MapSerializer(keySerializer, valueSerializer);
    } else {
      tmp$_2 = (tmp$_1 = module_0.getContextual_2n2k9f$(Kotlin.getKClassFromExpression(value))) != null ? tmp$_1 : serializer(Kotlin.getKClassFromExpression(value));
    }
    return Kotlin.isType(tmp$_3 = tmp$_2, KSerializer) ? tmp$_3 : throwCCE();
  }
  function elementSerializer($receiver, module_0) {
    var tmp$, tmp$_0;
    var $receiver_0 = filterNotNull($receiver);
    var destination = ArrayList_init(collectionSizeOrDefault($receiver_0, 10));
    var tmp$_1;
    tmp$_1 = $receiver_0.iterator();
    while (tmp$_1.hasNext()) {
      var item = tmp$_1.next();
      destination.add_11rb$(guessSerializer(item, module_0));
    }
    var tmp$_2;
    var set = HashSet_init();
    var list = ArrayList_init_0();
    tmp$_2 = destination.iterator();
    while (tmp$_2.hasNext()) {
      var e = tmp$_2.next();
      var key = e.descriptor.serialName;
      if (set.add_11rb$(key)) 
        list.add_11rb$(e);
    }
    var serializers = list;
    if (serializers.size > 1) {
      var destination_0 = ArrayList_init(collectionSizeOrDefault(serializers, 10));
      var tmp$_3;
      tmp$_3 = serializers.iterator();
      while (tmp$_3.hasNext()) {
        var item_0 = tmp$_3.next();
        destination_0.add_11rb$(item_0.descriptor.serialName);
      }
      throw IllegalStateException_init(('Serializing collections of different element types is not yet supported. ' + ('Selected serializers: ' + destination_0)).toString());
    }
    var selected = (tmp$ = singleOrNull(serializers)) != null ? tmp$ : serializer_0(kotlin_js_internal_StringCompanionObject);
    if (selected.descriptor.isNullable) {
      return selected;
    }
        Kotlin.isType(tmp$_0 = selected, KSerializer) ? tmp$_0 : throwCCE();
    var any$result;
    any$break:
      do {
        var tmp$_4;
        if (Kotlin.isType($receiver, Collection) && $receiver.isEmpty()) {
          any$result = false;
          break any$break;
        }
        tmp$_4 = $receiver.iterator();
        while (tmp$_4.hasNext()) {
          var element = tmp$_4.next();
          if (element == null) {
            any$result = true;
            break any$break;
          }
        }
        any$result = false;
      } while (false);
    if (any$result) {
      return get_nullable(selected);
    }
    return selected;
  }
  var package$io = _.io || (_.io = {});
  var package$ktor = package$io.ktor || (package$io.ktor = {});
  var package$shared = package$ktor.shared || (package$ktor.shared = {});
  var package$serialization = package$shared.serialization || (package$shared.serialization = {});
  var package$kotlinx = package$serialization.kotlinx || (package$serialization.kotlinx = {});
  package$kotlinx.KotlinxSerializationConverter = KotlinxSerializationConverter;
  package$kotlinx.serialization_j6y4a4$ = serialization;
  package$kotlinx.serialization_kcxkxo$ = serialization_0;
  package$kotlinx.serializerFromTypeInfo_wj9ktv$ = serializerFromTypeInfo;
  package$kotlinx.guessSerializer_uxyllt$ = guessSerializer;
  Kotlin.defineModule('ktor-ktor-shared-serialization-kotlinx-js-legacy', _);
  return _;
}));
